package com.zipcodewilmington.arrayutility;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {




    private T[] inputArray;


    public ArrayUtility(T[] inputArray) {
        this.inputArray = inputArray;
    }


    ArrayList<T> newArray = new ArrayList<>();


    public int countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {

        newArray.addAll(Arrays.asList(arrayToMerge));
        newArray.addAll(Arrays.asList(this.inputArray));

        int counter = 0;

        for(int i = 0; i < newArray.size(); i++){

            if(newArray.get(i).equals(valueToEvaluate)){
                counter++;
            }

        }

        return counter;

    }







    public T getMostCommonFromMerge(T[] arrayToMerge) {

        newArray.addAll(Arrays.asList(this.inputArray));
        newArray.addAll(Arrays.asList(arrayToMerge));


        int count = 1, tempCount;

        T mostCommon = newArray.get(0);

        T temp;

        for (int i = 0; i < (newArray.size() - 1); i++)
        {
            temp = newArray.get(i);
            tempCount = 0;
            for (int j = 1; j < newArray.size(); j++)
            {
                if (temp == newArray.get(j))
                    tempCount++;
            }
            if (tempCount > count)
            {
                mostCommon = temp;
                count = tempCount;
            }
        }


        return mostCommon;
    }








    public Integer getNumberOfOccurrences(T valueToEvaluate) {


        Integer counter = 0;


        for(int i = 0; i < inputArray.length; i++){

            if(inputArray[i].equals(valueToEvaluate)){
                counter++;
            }

        }

        return counter;
    }











    public T[] removeValue(T valueToRemove) {

        //Convert to String and manipulating
//        String str = inputArray.toString();
//
//        boolean checkContains = str.contains((CharSequence) valueToRemove);
//
//        if(checkContains = true){
//            str = str.replace((CharSequence) valueToRemove, "");
//        }
//
//        T[] returnValue = str;


        //Convert to arrayList and manipulating
//        ArrayList<T> newArray = new ArrayList<>();
//
//        newArray.remove(valueToRemove);
//
//
//        T[] returnValue = newArray.toArray();



        List<T> returnValue = new LinkedList<>(Arrays.asList(inputArray));


        for(int i = 0; i < returnValue.size(); i++){
            if(returnValue.get(i).equals(valueToRemove)){
                returnValue.remove(i);
            }
        }


        //return (T[]) returnValue.toArray();
        return returnValue.toArray(Arrays.copyOf(inputArray, returnValue.size()));


    }














}
